<script setup lang="ts">
import { ref, onMounted } from "vue";
import type { QTableProps } from "quasar";
import { useCounterMixin } from "@/stores/mixin";
import { useRoute } from "vue-router";
import { useInsigniaDataStore } from "@/modules/01_metadataNew/stores/InsigniaStore";
import dialogHeader from "@/components/DialogHeader.vue";
import TableDraggable from "@/modules/01_metadataNew/components/insignia/TableDraggable.vue";
import { useQuasar } from "quasar";
import http from "@/plugins/http";
import config from "@/app.config";
const store = useInsigniaDataStore();
const mixin = useCounterMixin();

const insigniaTypeName = defineModel<string>("insigniaTypeName", {
  required: true,
});

const {
  dialogRemove,
  dialogConfirm,
  showLoader,
  hideLoader,
  messageError,
  success,
} = mixin;
const $q = useQuasar();
const columns = ref<QTableProps["columns"]>([
  {
    name: "no",
    align: "left",
    label: "ลำดับ",
    sortable: false,
    field: "no",
    headerStyle: "font-size: 14px; width:0px",
    style: "font-size: 14px",
  },
  {
    name: "name",
    align: "left",
    label: "ชื่อเครื่องราชฯ",
    sortable: true,
    field: "name",
    headerStyle: "font-size: 14px",
    style: "font-size: 14px",
    sort: (a: string, b: string) =>
      a.localeCompare(b, undefined, { numeric: true, sensitivity: "base" }),
  },

  {
    name: "shortName",
    align: "left",
    label: "ชื่อย่อ",
    sortable: true,
    field: "shortName",
    headerStyle: "font-size: 14px",
    style: "font-size: 14px",
    sort: (a: string, b: string) =>
      a.localeCompare(b, undefined, { numeric: true, sensitivity: "base" }),
  },

  {
    name: "insigniaType",
    align: "left",
    label: "ลำดับชั้นเครื่องราชฯ",
    sortable: true,
    field: "insigniaType",
    headerStyle: "font-size: 14px",
    style: "font-size: 14px",
    sort: (a: string, b: string) =>
      a.localeCompare(b, undefined, { numeric: true, sensitivity: "base" }),
  },

  {
    name: "createdAt",
    align: "center",
    label: "วันที่สร้าง",
    sortable: true,
    field: "createdAt",
    headerStyle: "font-size: 14px",
    style: "font-size: 14px",
    sort: (a: string, b: string) =>
      a.localeCompare(b, undefined, { numeric: true, sensitivity: "base" }),
  },

  {
    name: "lastUpdatedAt",
    align: "center",
    label: "วันที่แก้ไข",
    sortable: true,
    field: "lastUpdatedAt",
    headerStyle: "font-size: 14px",
    style: "font-size: 14px",
    sort: (a: string, b: string) =>
      a.localeCompare(b, undefined, { numeric: true, sensitivity: "base" }),
  },

  {
    name: "lastUpdateFullName",
    align: "left",
    label: "ผู้ดำเนินการ",
    sortable: true,
    field: "lastUpdateFullName",
    headerStyle: "font-size: 14px",
    style: "font-size: 14px",
    sort: (a: string, b: string) =>
      a.localeCompare(b, undefined, { numeric: true, sensitivity: "base" }),
  },

  {
    name: "isActive",
    align: "left",
    label: "สถานะ",
    sortable: true,
    field: "isActive",
    headerStyle: "font-size: 14px",
    style: "font-size: 14px",
    sort: (a: string, b: string) =>
      a.localeCompare(b, undefined, { numeric: true, sensitivity: "base" }),
  },

  {
    name: "note",
    align: "left",
    label: "หมายเหตุ",
    sortable: true,
    field: "note",
    headerStyle: "font-size: 14px",
    style: "font-size: 14px",
    sort: (a: string, b: string) =>
      a.localeCompare(b, undefined, { numeric: true, sensitivity: "base" }),
  },
]);
const route = useRoute();
const id = ref<string>(route.params.id.toString());
const filterKeyword = ref<string>("");
const dialog = ref<boolean>(false);
const isActive = ref<boolean>(false);
const shortName = ref<string>("");
const note = ref<string>("");
const name = ref<string>("");
const insigniaTypeId = ref<string>("");
const nameRef = ref<any>(null);
const shortNameRef = ref<any>(null);
const dialogStatus = ref<string>("");
const editId = ref<string>("");
const visibleColumns = ref<string[]>([
  "no",
  "name",
  "shortName",
  "insigniaType",
  "createdAt",
  "lastUpdatedAt",
  "lastUpdateFullName",
  "isActive",
  "note",
]);

function closeDialog() {
  dialog.value = false;
}

function validateForm() {
  nameRef.value.validate();
  shortNameRef.value.validate();
  onSubmit();
}

async function fetchData(id: string) {
  showLoader();
  await http
    .get(config.API.insigniaTypeNewIdOrg(id))
    .then(async (res) => {
      insigniaTypeId.value = res.data.result.name;
      store.fetchData(res.data.result.insignias, res.data.result.name);
      insigniaTypeName.value = res.data.result.name;
    })
    .catch((err) => {
      messageError($q, err);
    })
    .finally(() => {
      hideLoader();
    });
}
onMounted(async () => {
  await fetchData(id.value);
});

async function onSubmit() {
  if (name.value.length > 0 && shortName.value.length > 0) {
    dialogConfirm(
      $q,
      async () => {
        dialogStatus.value === "create" ? addData() : editData(editId.value);
        closeDialog();
        name.value = "";
        shortName.value = "";
        isActive.value = false;
        note.value = "";
      },
      "ยืนยันการบันทึกข้อมูล",
      "ต้องการยืนยันการบันทึกข้อมูลนี้หรือไม่ ?"
    );
  }
}

async function addData() {
  await http
    .post(config.API.insigniaOrg, {
      name: name.value,
      isActive: isActive.value,
      shortName: shortName.value,
      note: note.value == "" ? "-" : note.value,
      insigniaTypeId: id.value,
    })
    .then(() => {
      fetchData(id.value);
      success($q, "บันทึกข้อมูลสำเร็จ");
    })
    .catch((err) => {
      messageError($q, err);
    })
    .finally(() => {
      hideLoader();
    });
}

async function editData(idData: string) {
  await http
    .put(config.API.insigniaNewIdOrg(idData), {
      name: name.value,
      isActive: isActive.value,
      shortName: shortName.value,
      note: note.value == "" ? "-" : note.value,
      insigniaTypeId: id.value,
    })
    .then(() => {
      fetchData(id.value);
      success($q, "บันทึกข้อมูลสำเร็จ");
    })
    .catch((err) => {
      messageError($q, err);
    })
    .finally(() => {
      hideLoader();
    });
}

async function deleteData(idData: string) {
  await http
    .delete(config.API.insigniaNewIdOrg(idData))
    .then(() => {
      fetchData(id.value);
      success($q, "ลบข้อมูลสำเร็จ");
    })
    .catch((err) => {
      messageError($q, err);
    })
    .finally(() => {
      hideLoader();
    });
}

import { defineEmits } from "vue";

const emit = defineEmits(["nameType"]);
const dialogOrder = ref<boolean>(false);
</script>

<template>
  <div class="q-pa-md">
    <q-toolbar style="padding: 0">
      <q-btn
        flat
        round
        color="primary"
        icon="add"
        @click.stop="
          () => {
            dialogStatus = 'create';
            dialog = true;
          }
        "
      >
        <q-tooltip> เพิ่มข้อมูล </q-tooltip>
      </q-btn>
      <q-btn
        v-if="store.row.length > 0"
        flat
        round
        color="blue-6"
        icon="mdi-sort"
        @click.stop="() => (dialogOrder = true)"
      >
        <q-tooltip> จัดลำดับการแสดงผล </q-tooltip>
      </q-btn>
      <TableDraggable v-model:modal="dialogOrder" :fetchData="fetchData" />
      <q-space />
      <div class="row q-gutter-sm">
        <q-input outlined dense v-model="filterKeyword" label="ค้นหา"></q-input>
        <q-select
          v-model="visibleColumns"
          multiple
          outlined
          dense
          options-dense
          :display-value="$q.lang.table.columns"
          emit-value
          map-options
          :options="columns"
          option-value="name"
          options-cover
          style="min-width: 150px"
        />
      </div>
    </q-toolbar>

    <d-table
      ref="table"
      :columns="columns"
      :rows="store.row"
      :filter="filterKeyword"
      row-key="name"
      flat
      bordered
      :paging="true"
      dense
      class="custom-header-table"
      :visible-columns="visibleColumns"
    >
      <template v-slot:header="props">
        <q-tr :props="props">
          <q-th v-for="col in props.cols" :key="col.name" :props="props">
            <span class="text-weight-bold">{{ col.label }}</span>
          </q-th>
          <q-th auto-width />
        </q-tr>
      </template>
      <template v-slot:body="props">
        <q-tr :props="props" class="cursor-pointer">
          <q-td v-for="(col, index) in props.cols" :key="col.id">
            <div v-if="col.name == 'no'">
              {{ props.rowIndex + 1 }}
            </div>
            <div v-else-if="col.name == 'isActive'">
              <q-icon
                v-if="col.value == false"
                name="mdi-close"
                color="red"
                class="text-h5"
              />
              <q-icon
                v-else
                name="mdi-check"
                color="positive"
                class="text-h5"
              />
            </div>
            <div v-else>
              {{ col.value }}
            </div>
          </q-td>
          <q-td auto-width>
            <q-btn
              color="edit"
              flat
              dense
              round
              class="q-mr-xs"
              size="12px"
              icon="edit"
              clickable
              @click.stop="
                () => {
                  dialogStatus = 'edit';
                  dialog = true;
                  editId = props.row.id;
                  name = props.row.name;
                  shortName = props.row.shortName;
                  note = props.row.note;
                  isActive = props.row.isActive;
                }
              "
            >
              <q-tooltip>แก้ไขข้อมูล</q-tooltip>
            </q-btn>
            <q-btn
              color="red"
              flat
              dense
              round
              size="12px"
              icon="mdi-delete"
              clickable
              @click.stop="
                dialogRemove($q, async () => await deleteData(props.row.id))
              "
              v-close-popup
            >
              <q-tooltip>ลบข้อมูล</q-tooltip>
            </q-btn>
          </q-td>
        </q-tr>
      </template>
    </d-table>

    <q-dialog v-model="dialog" class="dialog" persistent>
      <q-card style="min-width: 350px">
        <form @submit.prevent="validateForm">
          <q-card-section class="flex justify-between" style="padding: 0">
            <dialog-header
              :tittle="dialogStatus == 'edit' ? 'แก้ไขข้อมูล' : 'เพิ่มข้อมูล'"
              :close="closeDialog"
            />
          </q-card-section>

          <q-separator color="grey-4" />
          <q-card-section class="q-pa-none">
            <div class="col-12 q-ma-md">
              <q-input
                outlined
                :model-value="insigniaTypeId"
                label="ลำดับชั้นเครื่องราชฯ"
                dense
                lazy-rules
                borderless
                hide-bottom-space
                readonly
              />
            </div>
            <div class="col-12 q-ma-md">
              <q-input
                ref="nameRef"
                outlined
                v-model="name"
                label="ชื่อเครื่องราชฯ"
                dense
                lazy-rules
                borderless
                :rules="[
                  (val) => val.length > 0 || 'กรุณากรอกลำดับชั้นเครื่องราชฯ',
                ]"
                hide-bottom-space
              />
            </div>
            <div class="col-12 q-ma-md">
              <q-input
                ref="shortNameRef"
                outlined
                v-model="shortName"
                label="ชื่อย่อ"
                dense
                lazy-rules
                borderless
                :rules="[
                  (val) => val.length > 0 || 'กรุณากรอกลำดับชั้นเครื่องราชฯ',
                ]"
                hide-bottom-space
              />
            </div>
            <div class="col-12 q-ma-md">
              <q-input
                outlined
                v-model="note"
                label="หมายเหตุ"
                dense
                type="textarea"
                borderless
                hide-bottom-space
              />
            </div>
            <div
              class="col q-ma-md q-pa-sm bg-white border_custom text-weight-medium"
            >
              <div class="row items-center q-my-sm justify-between">
                <p class="q-ma-none">สถานะการใช้งาน</p>
                <label class="toggle-control">
                  <input type="checkbox" dense v-model="isActive" @change="" />
                  <span class="control"></span>
                </label>
              </div>
            </div>
          </q-card-section>

          <q-card-actions align="right">
            <q-btn
              id="onSubmit"
              type="submit"
              dense
              unelevated
              label="บันทึก"
              color="public"
            >
              <q-tooltip>บันทึกข้อมูล</q-tooltip>
            </q-btn>
          </q-card-actions>
        </form>
      </q-card>
    </q-dialog>
  </div>
</template>

<style scoped lang="scss">
.border_custom {
  border-radius: 6px !important;
  border: 1px solid #e1e1e1;
}
$toggle-background-color-on: #06884d;
$toggle-background-color-off: darkgray;
$toggle-control-color: white;
$toggle-width: 40px;
$toggle-height: 25px;
$toggle-gutter: 3px;
$toggle-radius: 50%;
$toggle-control-speed: 0.15s;
$toggle-control-ease: ease-in;

// These are our computed variables
// change at your own risk.
$toggle-radius: $toggle-height / 2;
$toggle-control-size: $toggle-height - ($toggle-gutter * 2);

.toggle-control {
  display: block;
  position: relative;
  padding-left: $toggle-width;
  margin-bottom: 12px;
  cursor: pointer;
  font-size: 22px;
  user-select: none;

  input {
    position: absolute;
    opacity: 0;
    cursor: pointer;
    height: 0;
    width: 0;
  }

  input:checked ~ .control {
    background-color: $toggle-background-color-on;

    &:after {
      left: $toggle-width - $toggle-control-size - $toggle-gutter;
    }
  }

  .control {
    position: absolute;
    top: -7px;
    left: -15px;
    height: $toggle-height;
    width: $toggle-width;
    border-radius: $toggle-radius;
    background-color: $toggle-background-color-off;
    transition: background-color $toggle-control-speed $toggle-control-ease;

    &:after {
      content: "";
      position: absolute;
      left: $toggle-gutter;
      top: $toggle-gutter;
      width: $toggle-control-size;
      height: $toggle-control-size;
      border-radius: $toggle-radius;
      background: $toggle-control-color;
      transition: left $toggle-control-speed $toggle-control-ease;
    }
  }
}
</style>
